USE tempdb
GO


--Basic wait stats
SELECT
	*
FROM sys.dm_os_wait_stats
GO



/*
--new tab... make some I/O waits
USE tempdb
GO

CREATE TABLE iowaits
(
	i INT IDENTITY(1,1) NOT NULL,
	j VARCHAR(200) NOT NULL,
	PRIMARY KEY (i)
)
GO

INSERT iowaits(j) VALUES(REPLICATE('a', 200))
GO

INSERT iowaits(j)
SELECT TOP(20000) 
	j 
FROM iowaits
ORDER BY 
	NEWID()
OPTION (MAXDOP 1)
GO 500
*/


--Check out our I/O waits..?

--check out IO_COMPLETION (sort spill) waits
SELECT
	*
FROM sys.dm_os_wait_stats
WHERE
	wait_type = 'IO_COMPLETION'
GO

--what's happening right this moment?
SELECT *
FROM sys.dm_os_waiting_tasks
WHERE
	wait_type = 'IO_COMPLETION'
GO

--what happened HISTORICALLY?
SELECT *
FROM sys.dm_exec_session_wait_stats
WHERE
	wait_type = 'IO_COMPLETION'
GO




--Live Query Statistics and Actual Plan Metrics 
INSERT iowaits(j) 
SELECT TOP(1) 
	j 
FROM 
(
	SELECT TOP(200000)
		x2.j
	FROM
	(
		SELECT DISTINCT TOP(400000)
			LEFT(CONCAT(i, j), 200) AS k
		FROM iowaits
	) AS x1
	CROSS APPLY
	(
		SELECT TOP(1)
			j
		FROM iowaits AS x3
		WHERE
			x3.i = CONVERT(INT, REPLACE(x1.k, 'a', ''))
	) AS x2
	ORDER BY NEWID()
) AS x2 
ORDER BY NEWID() 
OPTION (MAXDOP 1)
GO




--inputbuffer DMV...


--A proc to test
CREATE PROC dbo.myproc 
	@x INT
AS
BEGIN
	WAITFOR DELAY '00:10:10'
END
GO


--run the proc...
EXEC dbo.myproc 1234567
GO


/*
--The old way...
SELECT
	t.*
FROM sys.dm_exec_requests AS r
CROSS APPLY sys.dm_exec_sql_text (r.plan_handle) AS t
WHERE
	r.session_id = 55
GO



DBCC INPUTBUFFER(55)
GO



--The new way...
SELECT
	t.*,
	b.*
FROM sys.dm_exec_requests AS r
CROSS APPLY sys.dm_exec_sql_text (r.plan_handle) AS t
CROSS APPLY sys.dm_exec_input_buffer(r.session_id, r.request_id) AS b
WHERE
	r.session_id = 55
GO
*/

