--2014 vs 2016 Columnstores?
USE tempdb
GO



--First test on 2014, then 2016...


CREATE TABLE nonclustered_columnstore
(
	i INT NOT NULL,
	j INT NOT NULL
)
GO


CREATE NONCLUSTERED COLUMNSTORE INDEX idx 
ON nonclustered_columnstore (i, j)
GO


INSERT nonclustered_columnstore (i, j) 
SELECT 1, 2
GO




CREATE TABLE clustered_columnstore
(
	i INT NOT NULL,
	j INT NOT NULL
)
GO


CREATE CLUSTERED COLUMNSTORE INDEX idx
ON clustered_columnstore
GO


INSERT clustered_columnstore (i, j)
SELECT 1, 2
GO


ALTER TABLE clustered_columnstore
ADD PRIMARY KEY (i, j)
GO





--test with more data
CREATE TABLE columnstore_data_test
(
	i INT NOT NULL,
	j INT NOT NULL
)
GO


CREATE CLUSTERED COLUMNSTORE INDEX idx
ON columnstore_data_test
GO


;WITH 
a(x) AS (SELECT 1 UNION ALL SELECT 1),
b(x) AS (SELECT 1 FROM a AS y, a AS z),
c(x) AS (SELECT 1 FROM b AS y, b AS z),
d(x) AS (SELECT 1 FROM c AS y, c AS z),
e(x) AS (SELECT 1 FROM d AS y, d AS z),
f(x) AS (SELECT 1 FROM e AS y, e AS z)
INSERT columnstore_data_test
SELECT TOP(20000000)
	ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) AS i,
	ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) AS j
FROM f
GO



SELECT MIN(i), MAX(j)
FROM columnstore_data_test
GO



SELECT
	MAX(k)
FROM
(
	SELECT ROW_NUMBER() OVER (ORDER BY i) AS k
	FROM columnstore_data_test
) AS v
GO



